﻿@model UploadImageViewModel

@Styles.Render("~/Content/kendo/css")
@Scripts.Render("~/bundles/kendo")
<!-- =============================================edit logo box============================================= -->
<link href="~/Content/jquery.Jcrop.css" rel="stylesheet" />

<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
    <h3 id="myModalLabel3" class="text-left">Upload image</h3>
</div>
   <script type="text/javascript">
       function OnSuccessUploadLogo(e) {

           var imageUrl = e.response.imageUrl; var imageName = e.response.imageName; var message = e.response.message;

           if (message != undefined && message != "") {

               $("#Message").html(message);
               hasImage = false;
               cropCreated = false;
               $("#actionZone").hideLoading();
           }
           else {
               $("#Message").html("");
               hasImage = true;
               cropCreated = false;
               $("#imgPreview").attr('src', imageUrl + "?" + Math.random());
               $("#txtImageUrl").val(imageName);
               $("#actionZone").hideLoading();
               $("#btnSave").removeClass('hidden');
           }
       }
    </script>
<div id="actionZone" class="modal-body inline">

    <div id="imageUpload" class="pull-left upload-logo">
        <span id="Message" style="color: red"></span>
        <p>You can upload a JPG, GIF or PNG file</p>
              
          @(Html.Kendo().Upload().Messages(model => model.Select("Upload Image"))
        .Name("files").Multiple(false).ShowFileList(true)
        .Async(async => async
            .Save("UploadImage",Model.Controller, new { directory = Model.Directory , childDirectory = Model.ChildDirectory })
            .AutoUpload(true))
            .Events(evt => evt.Success("OnSuccessUploadLogo"))
            .HtmlAttributes(new { accept="image/gif,image/png, image/jpeg,image/jpg, image/jpg"})   //image/*
        )
        <div class="progress-bar pull-left"></div>
        <span>By clicking “Upload”, you certify that you have the right to distribute this photo.</span>
    </div>
    <div id="imagePreview" class="pull-left image-prw">
        <img id="imgPreview"  src="@Url.Content(Model.ImageUrl)" />
        <input type="hidden" value="" id="txtImageUrl" />
    </div>
</div>
<div class="modal-footer text-right">
    <button id="btnSave" class="btn btn-success hidden loading" data-loading-text="Uploading...">Upload</button>
</div>
@* Add Show loading for test *@
@Scripts.Render("~/bundles/showLoading")
@Scripts.Render("~/bundles/jquery.unobtrusive-ajax.min")

<script type="text/javascript">
    var jcrop = null;
    var hasImage = false;
    var cropCreated = false;
    var x = 0, y = 0, w = 0, h = 0;

    $("#imgPreview").load(function () {
        //onload = "createJcrop()
        createJcrop();
    });
    function CuteWebUI_AjaxUploader_OnPostback() {
        $("#actionZone").showLoading({ overlayZIndex: 10000, indicatorZIndex: 10001 });
        $("#frmUploadLogo").submit();
    }

    function createJcrop() {
        if (!hasImage || cropCreated) { return; }

        if (jcrop != null) {
            jcrop.destroy();
        }

        jcrop = $.Jcrop("#imgPreview", {
            onChange: setCoords,
            onRelease: setSelected,
            aspectRatio: 1,
        });

        cropCreated = true;

        setSelected();
    }
    function setSelected() {

        // set position
        var w = $("#imgPreview").width();
        var h = $("#imgPreview").height();
      

        jcrop.setSelect([
                    7,
                    7,
                    Math.round(w / 2),
                    Math.round(h / 2)
        ]);

        jcrop.focus();
    }
    
 

    function setCoords(c) {
        x = c.x;
        y = c.y;

        w = c.w;
        h = c.h;
    };

    function initialize() {
        buttonInit();

        $("#btnSave").click(function () {
            $(this).val('loading');

            $.ajax({
                url: "@Url.Action("CropLogo", Model.Controller)",
                type: "POST",
                data: {
                    directory: '@Model.Directory',
                    childDirectory: '@Model.ChildDirectory',
                    imageName: $("#txtImageUrl").val(),
                    x: x,
                    y: y,
                    w: w,
                    h: h
                },
                beforeSend: function (jqXHR, settings) {

                },
                success: function (data) {
                    if (data.result) {
                        location.reload();
                    }
                    else {
                        buttonReset();
                    }
                },
                complete: function (jqXHR, textStatus) {

                },
                error: function (xhr, status, error) {
                    buttonReset();
                }
            });
        });
    }

    // load script dynamically [danial]
    var loadScript = function (scriptURL, failureCallback) {
        var script = document.createElement('script'),
            scriptProtocol = scriptURL.match(/^([a-zA-Z]+:)\/\//);
        script.setAttribute('type', 'text/javascript');

        if (navigator.product === 'Gecko' &&
            navigator.userAgent.indexOf('KHTML') === -1 &&
            window.location.protocol === 'file:' &&
            (!scriptProtocol || scriptProtocol[1] === 'file:')) {

            var req = new XMLHttpRequest();
            req.open('GET', scriptURL, true);
            req.onreadystatechange = function () {
                if (req.readyState === 4) {
                    if (req.status === 0)
                        script.textContent = req.responseText;
                    else
                        failureCallback();
                }
            };
            try {
                req.send(null);
            }
            catch (e) {
                failureCallback();
            }
        }
        else {
            script.setAttribute('src', scriptURL);
            script.onerror = failureCallback;
        }

        document.getElementsByTagName('head')[0].appendChild(script);
    };

    // form initialize
    var buttonLoaded = true;
    var jcropLoaded = true;

    loadScript("@Url.Content("~/Scripts/jquery.Jcrop.min.js")", function () {
        jcropLoaded = false;
    });

    loadScript("@Url.Content("~/bundles/button")", function () {
        buttonLoaded = false;
    });

    if (buttonLoaded && jcropLoaded) {
        initialize();
    }
</script>
